// Bug.h - slaves

#import <objectbase/SwarmObject.h>
#import <space.h>
#import <gui.h>
#import "ObjsSpace.h"

@interface Bug: SwarmObject
{
  int xPos, yPos;		// bug's position
  int worldXSize, worldYSize;
  
  id <Grid2d> world;
  id objs;

  int haveEaten;		// # eaten foods
  int lifetime;			// cycles the bug still has to live & learn
  int age;			// bug's age

  float DELTA,delta;		// learning constants
  
  float weights[4][4];		// our ANN
  int winner;			// the winner of the ANN
}

- initWeights;			// initialize the weights of the ANN
- setLifeTime: (int)time;	// sets the initial life time
- setLearningConstants: (float)delta_big: (float)delta_small;	// set learning constants
- setWorld: w Objs: o;		// set the world the bug lives in
- createEnd;

- setX: (int)x Y: (int)y;	// set position
- getX: (int*)x Y: (int*)y;	// get position
- step: (float[4])input;	// go according to the input vector
- drawSelfOn: (id <Raster>)r;

@end

