// ModelSwarm.h

#import "Bug.h"
#import "Master.h"
#import "ObjsSpace.h"
#import <objectbase/Swarm.h>
#import <space.h>
#import "NavDest.h"

@interface ModelSwarm: Swarm
{
  int worldXSize, worldYSize;	// world size
  float seedProbObst;		// average amount of obstacles in %
  float seedProbFood;		// average amount of food in %
  float bugDensity;		// average amount of bugs in %
  int bugLifeTime;		// initial bug life time
  float DELTA,delta;		// ANN weights

  ObjsSpace *objs;		// the obstacles are defined here
  id <Grid2d> world;		// the world

  id bugList;			// a list of bugs
  id masterList;		// the master organized as a list
  id navList;			// the destination the master chooses for every bug
  id modelActions;
  id modelSchedule;
}

- getWorld;			// returns world
- getObjs;			// returns the objstacles space
- getBugList;			// returns bugList
- getMaster;			// returns masterList

+ createBegin: aZone;
- createEnd;
- buildObjects;
- buildActions;
- activateIn: swarmContext;

@end


